#include "piece.h"

// Q2
int dessine_grille() {
    for(int i=0; i<=size; i++)
        drawLine(marge, margeScore+i*z, marge+size*z, margeScore+i*z, BLACK);
    for(int i=0; i<=size; i++)
        drawLine(marge+i*z, margeScore, marge+i*z, margeScore+size*z, BLACK);
}

// Q7
void test_deplacement() {
    Piece p;
    p.dessine();
    int i;
    while((i=getKey()) != KEY_RETURN) {
        switch(i) {
        case KEY_LEFT:  --p.x; break;
        case KEY_RIGHT: ++p.x; break;
        case KEY_UP:    --p.y; break;
        case KEY_DOWN:  ++p.y; break;
        }
        clearWindow();
        dessine_grille();
        p.dessine();
    }
}

// Q19
void indicateur(const Plateau& P, const Piece& p) {
    Color c = (P.verifie(p)? GREEN: RED);
    fillCircle(marge+size*z/2, margeScore/2, 10, c);
}

// Q15
void jeu() {
    Plateau P(size, size);
    dessine_grille();
    int score=0;
    while(true) {
        Piece p;
        p.dessine();
        indicateur(P,p); // Q19
        if(P.positions(p) == 0)
            break;
        while(true) {
            Piece p0=p;
            int i = getKey();
            switch(i) {
            case KEY_LEFT:  --p.x; break;
            case KEY_RIGHT: ++p.x; break;
            case KEY_UP:    --p.y; break;
            case KEY_DOWN:  ++p.y; break;
            }
            if(! P.contient(p)) {
                p = p0;
                continue;
            }
            if(p.x!=p0.x || p.y!=p0.y) {
                P.dessine();
                dessine_grille();
                p.dessine();
                indicateur(P,p); // Q19
            }
            if(i == KEY_RETURN && P.verifie(p)) {
                P.absorbe(p);
                // Q17
                int i=P.detruis();
                if(i>0) {
                    milliSleep(100);
                    P.dessine();
                    // Q18
                    score+=i;
                    fillRect(0,0,marge+size*z+marge, margeScore-1,WHITE);
                    drawString(marge, margeScore-5, std::to_string(score),
                               RED, 20);
                }
                break;
            }
        }
    }
}

int main() {
    initRandom();
    openWindow(marge+size*z+marge, margeScore+size*z+marge, "Jeu 10x10"); //Q1
    dessine_grille();
    // test_deplacement();
    jeu();
    endGraphics();
    return 0;
}
